struct Solution;

impl Solution {
    pub fn remove_duplicates(nums: &mut Vec<i32>) -> i32 {
        let l = nums.len();
        if l == 0 {
            return 0;
        }
        let mut cur = 0;
        for i in 1..l {
            if nums[i] > nums[cur] {
                cur += 1;
                nums[cur] = nums[i];
            }
        }

        (cur + 1) as i32
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_remove_duplicates() {
        let mut nums = vec![1, 1, 2];
        assert_eq!(Solution::remove_duplicates(&mut nums), 2);
        assert_eq!(nums[..2], vec![1, 2]);
    }

    #[test]
    fn test_remove_duplicates_2() {
        let mut nums = vec![1, 1, 2, 3, 3];
        assert_eq!(Solution::remove_duplicates(&mut nums), 3);
        assert_eq!(nums[..3], vec![1, 2, 3]);
    }
}
