struct Solution;

impl Solution {
    pub fn longest_common_prefix(strs: Vec<String>) -> String {
        if strs.len() == 1 { return strs[0].clone(); }

        let mut j = 0;
        let mut res = String::new();
        loop {
            let mut flag = true;
            for i in 0..strs.len()-1 {
                if j < strs[i].len() && j < strs[i+1].len()  {
                    let ci = strs[i].chars().nth(j).unwrap();
                    let cii =  strs[i+1].chars().nth(j).unwrap();
                    if ci != cii {
                        flag = false;
                    }
                } else {
                    return res;
                }
            }
            if flag {
                res.push(strs[0].chars().nth(j).unwrap());
            } else {
                return res;
            }
            j+=1;

        }

    }
}

#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_longest_common_prefix() {
        assert_eq!(Solution::longest_common_prefix(vec![String::from("flower"), String::from("flow"), String::from("flight")]), String::from("fl"));
        assert_eq!(Solution::longest_common_prefix(vec![String::from("dog"), String::from("racecar"), String::from("car")]), String::from(""));
    }
}