struct Solution;
use std::convert::TryFrom;

impl Solution {
    pub fn reverse(x: i32) -> i32 {
        let mut x = x as i64;
        let sign = if x > 0 {
            1
        } else {
            x = -1*x;
            -1
        };
        let mut res: i64 = 0;
        while x > 0 {
            res = res * 10 + x % 10;
            x /= 10;
        }

        i32::try_from(res*sign).unwrap_or(0)
        // if res > std::i32::MAX as i64 || res < std::i32::MIN as i64 {
        //     return 0;
        // }
        // res as i32 * sign

    }
}


#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_reverse() {
        assert_eq!(Solution::reverse(123), 321);
        assert_eq!(Solution::reverse(-123), -321);
        assert_eq!(Solution::reverse(120), 21);
        assert_eq!(Solution::reverse(1534236469), 0);
    }
}

