struct Solution;

impl Solution {
    pub fn remove_element(nums: &mut Vec<i32>, val: i32) -> i32 {
        match nums.is_empty() {
            true => 0,
            false => {
                let mut cur = 0;
                for i in 0..nums.len() {
                    if nums[i] != val {
                        nums[cur] = nums[i];
                        cur += 1;
                    }
                }

                cur as i32
            }
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_remove_element() {
        let mut nums = vec![3, 2, 2, 3];
        assert_eq!(Solution::remove_element(&mut nums, 3), 2);
        assert_eq!(nums[..2], vec![2, 2]);
    }
}
