struct Solution;
impl Solution {
    pub fn trap(height: Vec<i32>) -> i32 {
        let n = height.len();
        if n == 0 || n == 1 {
            return 0;
        }
        let mut max_l = height[0];
        let mut max_r = height[n - 1];
        let mut sum = 0;
        let (mut left, mut right) = (0, n - 1);
        while left < right {
            println!("left: {}, right: {}, max_l: {}, max_r: {}, sum: {}", left, right, max_l, max_r, sum);
            if max_l <= max_r {
                left += 1;

                sum += (max_l - height[left]).max(0);
                max_l = max_l.max(height[left]);
            } else {
                right -= 1;

                sum += (max_r - height[right]).max(0);
                max_r = max_r.max(height[right]);
            }
            println!("left: {}, right: {}, sum: {}", left, right, sum);
        }

        sum
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_trap() {
        assert_eq!(Solution::trap(vec![0, 1, 0, 2, 1, 0, 1, 3, 2, 1, 2, 1]), 6);
    }

    #[test]
    fn test_trap_1() {
        assert_eq!(Solution::trap(vec![4, 2, 0, 3, 2, 5]), 9);
    }

    #[test]
    fn test_trap_2() {
        assert_eq!(Solution::trap(vec![4, 2, 3]), 1);
    }


    #[test]
    fn test_trap_3() {
        assert_eq!(Solution::trap(vec![5,5,1,7,1,1,5,2,7,6]), 23);
    }
}
