struct Solution;

impl Solution {
    pub fn climb_stairs(n: i32) -> i32 {


        let mut a = 1;
        let mut b = 2;
        match n {
            1 => return 1,
            2 => return 2,
            _ => {
                for _ in 3..=n {
                    let tmp = a + b;
                    a = b;
                    b = tmp;
                }
            }
        }
        b

    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_climb_stairs() {
        let n = 4;
        let res = Solution::climb_stairs(n);
        assert_eq!(res, 5);
    }
}