struct Solution;

impl Solution {
    pub fn move_zeroes(nums: &mut Vec<i32>) {
        let mut cur = 0;
        for i in 0..nums.len() {
            if nums[i] != 0 {
                nums[cur] = nums[i];
                cur += 1;
            }
        }
        for i in cur..nums.len() {
            nums[i] = 0;
        }

    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let mut v1 = vec![0, 1, 0, 3, 12];
        Solution::move_zeroes(&mut v1);
        let v2 = vec![1, 3, 12, 0, 0];
        assert_eq!(v1, v2);
    }
}