struct Solution;
use std::convert::TryFrom;

impl Solution {
    pub fn is_palindrome(x: i32) -> bool {
        if x < 0 { return false; }
        let mut pal_num: i64 = 0;
        let mut y = x as i64;
        while y > 0 {
            pal_num = 10*pal_num + y%10;
            y /= 10;
        }

        let pal_num = i32::try_from(pal_num).unwrap_or(-1);
        if x == pal_num { true } else { false }


    }
}

#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_is_palindrome() {
        assert_eq!(Solution::is_palindrome(121), true);
        assert_eq!(Solution::is_palindrome(-121), false);
        assert_eq!(Solution::is_palindrome(10), false);
    }
}