struct Solution;

impl Solution {
    pub fn roman_to_int(s: String) -> i32 {
        // let vi = vec![1,4,5,9,10,40,50,90,100,400,500,900,1000];
        // let va = vec!["I", "IV", "V", "IX", "X", "XL", "L", "XC", "C", "CD", "D", "CM", "M"];
        let mut m = std::collections::HashMap::new();
        // vi.iter().zip(va).for_each(|(&k,v)| { m.insert(v, k); });
        m.insert("I", 1);
        m.insert("V", 5);
        m.insert("X", 10);
        m.insert("L", 50);
        m.insert("C", 100);
        m.insert("D", 500);
        m.insert("M", 1000);

        let mut res = 0;
        let l = s.len();
        let mut i = 0;
        while i < l  {
            let ci = s.chars().nth(i).unwrap().to_string();
            let vi = m.get(ci.as_str()).unwrap();
            if i+1 == l {
                res += *vi;
                break;
            }
            let cj  = s.chars().nth(i+1).unwrap().to_string();
            let vj = m.get(cj.as_str()).unwrap();
            if vi < vj {
                res += vj-vi;
                i += 2;
            } else {
                res += *vi;
                i += 1;

            }
        }

        res

    }
}

#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_roman_to_int() {
        assert_eq!(Solution::roman_to_int("III".to_string()), 3);
        assert_eq!(Solution::roman_to_int("IV".to_string()), 4);
        assert_eq!(Solution::roman_to_int("IX".to_string()), 9);
        assert_eq!(Solution::roman_to_int("LVIII".to_string()), 58);
        assert_eq!(Solution::roman_to_int("MCMXCIV".to_string()), 1994);
    }
}