struct Solution;

impl Solution {
    pub fn three_sum(nums: Vec<i32>) -> Vec<Vec<i32>> {
        let mut res = std::collections::HashSet::<(i32, i32, i32)>::new();
        let mut nums = nums;
        nums.sort();

        for i in 0..nums.len()-1 {
            let r = Solution::two_sum(&nums[i+1..], -1*nums[i]);
            res.extend(r);
        }
        let r = res.iter().map(|&(x,y,z)| { vec![x,y,z]}).collect();
        r


    }

    fn two_sum(nums:&[i32], target: i32) -> std::collections::HashSet<(i32,i32,i32)> {

        let mut res: std::collections::HashSet<(i32, i32, i32)> = std::collections::HashSet::new();
        if nums.len() < 2 {
            return res;
        }
        let mut s: std::collections::HashMap<i32, i32> = std::collections::HashMap::new();
        for (idx, num) in nums.iter().enumerate() {
            let left = target - num;
            match s.get(num) {
                Some(&v) => { res.insert((-1*target, nums[v as usize], nums[idx])); },
                None => { s.insert(left, idx as i32); }
            }
        }
        res


    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let nums = vec![3, 2, 4];
        let res = Solution::three_sum(nums);
        let expect: Vec<Vec<i32>> = vec![];
        assert_eq!(res, expect)
    }

    #[test]
    fn test_case_2() {
        let nums = vec![-1, 0, 1, 2, -1, -4];
        let res = Solution::three_sum(nums);
        let expect = vec![ vec![-1, -1, 2], vec![-1, 0, 1] ];
        assert_eq!(res, expect)
    }
}